--- MPlayer-1.0rc1/libmpcodecs/native/minilzo.c
+++ MPlayer-1.0rc1/libmpcodecs/native/minilzo.c
@@ -748,555 +1926,260 @@
 #define LZO_BASE 65521u
 #define LZO_NMAX 5552
 
-#define LZO_DO1(buf,i)  {s1 += buf[i]; s2 += s1;}
+#define LZO_DO1(buf,i)  s1 += buf[i]; s2 += s1
 #define LZO_DO2(buf,i)  LZO_DO1(buf,i); LZO_DO1(buf,i+1);
 #define LZO_DO4(buf,i)  LZO_DO2(buf,i); LZO_DO2(buf,i+2);
 #define LZO_DO8(buf,i)  LZO_DO4(buf,i); LZO_DO4(buf,i+4);
 #define LZO_DO16(buf,i) LZO_DO8(buf,i); LZO_DO8(buf,i+8);
 
 LZO_PUBLIC(lzo_uint32)
-lzo_adler32(lzo_uint32 adler, const lzo_byte *buf, lzo_uint len)
+lzo_adler32(lzo_uint32 adler, const lzo_bytep buf, lzo_uint len)
 {
     lzo_uint32 s1 = adler & 0xffff;
     lzo_uint32 s2 = (adler >> 16) & 0xffff;
-    int k;
+    unsigned k;
 
     if (buf == NULL)
-	return 1;
+        return 1;
 
     while (len > 0)
     {
-	k = len < LZO_NMAX ? (int) len : LZO_NMAX;
-	len -= k;
-	if (k >= 16) do
-	{
-	    LZO_DO16(buf,0);
-	    buf += 16;
-	    k -= 16;
-	} while (k >= 16);
-	if (k != 0) do
-	{
-	    s1 += *buf++;
-	    s2 += s1;
-	} while (--k > 0);
-	s1 %= LZO_BASE;
-	s2 %= LZO_BASE;
+        k = len < LZO_NMAX ? (unsigned) len : LZO_NMAX;
+        len -= k;
+        if (k >= 16) do
+        {
+            LZO_DO16(buf,0);
+            buf += 16;
+            k -= 16;
+        } while (k >= 16);
+        if (k != 0) do
+        {
+            s1 += *buf++;
+            s2 += s1;
+        } while (--k > 0);
+        s1 %= LZO_BASE;
+        s2 %= LZO_BASE;
     }
     return (s2 << 16) | s1;
 }
 
-LZO_PUBLIC(int)
-lzo_memcmp(const lzo_voidp s1, const lzo_voidp s2, lzo_uint len)
-{
-#if (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMCMP)
-    return memcmp(s1,s2,len);
-#else
-    const lzo_byte *p1 = (const lzo_byte *) s1;
-    const lzo_byte *p2 = (const lzo_byte *) s2;
-    int d;
-
-    if (len > 0) do
-    {
-	d = *p1 - *p2;
-	if (d != 0)
-	    return d;
-	p1++;
-	p2++;
-    }
-    while (--len > 0);
+#undef LZO_DO1
+#undef LZO_DO2
+#undef LZO_DO4
+#undef LZO_DO8
+#undef LZO_DO16
+
+#undef lzo_memcmp
+#undef lzo_memcpy
+#undef lzo_memmove
+#undef lzo_memset
+#if !defined(__LZO_MMODEL_HUGE)
+#  undef LZO_HAVE_MM_HUGE_PTR
+#endif
+#define lzo_hsize_t             lzo_uint
+#define lzo_hvoid_p             lzo_voidp
+#define lzo_hbyte_p             lzo_bytep
+#define LZOLIB_PUBLIC(r,f)      LZO_PUBLIC(r) f
+#define lzo_hmemcmp             lzo_memcmp
+#define lzo_hmemcpy             lzo_memcpy
+#define lzo_hmemmove            lzo_memmove
+#define lzo_hmemset             lzo_memset
+#define __LZOLIB_HMEMCPY_CH_INCLUDED 1
+#if !defined(LZOLIB_PUBLIC)
+#  define LZOLIB_PUBLIC(r,f)    r __LZOLIB_FUNCNAME(f)
+#endif
+LZOLIB_PUBLIC(int, lzo_hmemcmp) (const lzo_hvoid_p s1, const lzo_hvoid_p s2, lzo_hsize_t len)
+{
+#if (LZO_HAVE_MM_HUGE_PTR) || !defined(HAVE_MEMCMP)
+    const lzo_hbyte_p p1 = (const lzo_hbyte_p) s1;
+    const lzo_hbyte_p p2 = (const lzo_hbyte_p) s2;
+    if __lzo_likely(len > 0) do
+    {
+        int d = *p1 - *p2;
+        if (d != 0)
+            return d;
+        p1++; p2++;
+    } while __lzo_likely(--len > 0);
     return 0;
+#else
+    return memcmp(s1, s2, len);
 #endif
 }
-
-LZO_PUBLIC(lzo_voidp)
-lzo_memcpy(lzo_voidp dest, const lzo_voidp src, lzo_uint len)
+LZOLIB_PUBLIC(lzo_hvoid_p, lzo_hmemcpy) (lzo_hvoid_p dest, const lzo_hvoid_p src, lzo_hsize_t len)
 {
-#if (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMCPY)
-    return memcpy(dest,src,len);
-#else
-    lzo_byte *p1 = (lzo_byte *) dest;
-    const lzo_byte *p2 = (const lzo_byte *) src;
-
+#if (LZO_HAVE_MM_HUGE_PTR) || !defined(HAVE_MEMCPY)
+    lzo_hbyte_p p1 = (lzo_hbyte_p) dest;
+    const lzo_hbyte_p p2 = (const lzo_hbyte_p) src;
     if (len <= 0 || p1 == p2)
-	return dest;
+        return dest;
     do
-	*p1++ = *p2++;
-    while (--len > 0);
+        *p1++ = *p2++;
+    while __lzo_likely(--len > 0);
     return dest;
+#else
+    return memcpy(dest, src, len);
 #endif
 }
-
-LZO_PUBLIC(lzo_voidp)
-lzo_memmove(lzo_voidp dest, const lzo_voidp src, lzo_uint len)
+LZOLIB_PUBLIC(lzo_hvoid_p, lzo_hmemmove) (lzo_hvoid_p dest, const lzo_hvoid_p src, lzo_hsize_t len)
 {
-#if (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMMOVE)
-    return memmove(dest,src,len);
-#else
-    lzo_byte *p1 = (lzo_byte *) dest;
-    const lzo_byte *p2 = (const lzo_byte *) src;
-
+#if (LZO_HAVE_MM_HUGE_PTR) || !defined(HAVE_MEMMOVE)
+    lzo_hbyte_p p1 = (lzo_hbyte_p) dest;
+    const lzo_hbyte_p p2 = (const lzo_hbyte_p) src;
     if (len <= 0 || p1 == p2)
-	return dest;
-
+        return dest;
     if (p1 < p2)
     {
-	do
-	    *p1++ = *p2++;
-	while (--len > 0);
+        do
+            *p1++ = *p2++;
+        while __lzo_likely(--len > 0);
     }
     else
     {
-	p1 += len;
-	p2 += len;
-	do
-	    *--p1 = *--p2;
-	while (--len > 0);
+        p1 += len;
+        p2 += len;
+        do
+            *--p1 = *--p2;
+        while __lzo_likely(--len > 0);
     }
     return dest;
-#endif
-}
-
-LZO_PUBLIC(lzo_voidp)
-lzo_memset(lzo_voidp s, int c, lzo_uint len)
-{
-#if (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMSET)
-    return memset(s,c,len);
 #else
-    lzo_byte *p = (lzo_byte *) s;
-
-    if (len > 0) do
-	*p++ = LZO_BYTE(c);
-    while (--len > 0);
-    return s;
+    return memmove(dest, src, len);
 #endif
 }
-
-#include <stdio.h>
-
-#if 0
-#  define IS_SIGNED(type)       (((type) (1ul << (8 * sizeof(type) - 1))) < 0)
-#  define IS_UNSIGNED(type)     (((type) (1ul << (8 * sizeof(type) - 1))) > 0)
-#else
-#  define IS_SIGNED(type)       (((type) (-1)) < ((type) 0))
-#  define IS_UNSIGNED(type)     (((type) (-1)) > ((type) 0))
-#endif
-
-static lzo_bool schedule_insns_bug(void);
-static lzo_bool strength_reduce_bug(int *);
-
-#if 0 || defined(LZO_DEBUG)
-static lzo_bool __lzo_assert_fail(const char *s, unsigned line)
+LZOLIB_PUBLIC(lzo_hvoid_p, lzo_hmemset) (lzo_hvoid_p s, int c, lzo_hsize_t len)
 {
-#if defined(__palmos__)
-    printf("LZO assertion failed in line %u: '%s'\n",line,s);
+#if (LZO_HAVE_MM_HUGE_PTR) || !defined(HAVE_MEMSET)
+    lzo_hbyte_p p = (lzo_hbyte_p) s;
+    if __lzo_likely(len > 0) do
+        *p++ = (unsigned char) c;
+    while __lzo_likely(--len > 0);
+    return s;
 #else
-    fprintf(stderr,"LZO assertion failed in line %u: '%s'\n",line,s);
+    return memset(s, c, len);
 #endif
-    return 0;
 }
-#  define __lzo_assert(x)   ((x) ? 1 : __lzo_assert_fail(#x,__LINE__))
-#else
-#  define __lzo_assert(x)   ((x) ? 1 : 0)
-#endif
-
-static lzo_bool basic_integral_check(void)
-{
-    lzo_bool r = 1;
-    lzo_bool sanity;
-
-    r &= __lzo_assert(CHAR_BIT == 8);
-    r &= __lzo_assert(sizeof(char) == 1);
-    r &= __lzo_assert(sizeof(short) >= 2);
-    r &= __lzo_assert(sizeof(long) >= 4);
-    r &= __lzo_assert(sizeof(int) >= sizeof(short));
-    r &= __lzo_assert(sizeof(long) >= sizeof(int));
-
-    r &= __lzo_assert(sizeof(lzo_uint32) >= 4);
-    r &= __lzo_assert(sizeof(lzo_uint32) >= sizeof(unsigned));
-#if defined(__LZO_STRICT_16BIT)
-    r &= __lzo_assert(sizeof(lzo_uint) == 2);
-#else
-    r &= __lzo_assert(sizeof(lzo_uint) >= 4);
-    r &= __lzo_assert(sizeof(lzo_uint) >= sizeof(unsigned));
-#endif
-
-#if defined(SIZEOF_UNSIGNED)
-    r &= __lzo_assert(SIZEOF_UNSIGNED == sizeof(unsigned));
-#endif
-#if defined(SIZEOF_UNSIGNED_LONG)
-    r &= __lzo_assert(SIZEOF_UNSIGNED_LONG == sizeof(unsigned long));
-#endif
-#if defined(SIZEOF_UNSIGNED_SHORT)
-    r &= __lzo_assert(SIZEOF_UNSIGNED_SHORT == sizeof(unsigned short));
-#endif
-#if !defined(__LZO_IN_MINILZO)
-#if defined(SIZEOF_SIZE_T)
-    r &= __lzo_assert(SIZEOF_SIZE_T == sizeof(size_t));
-#endif
-#endif
+#undef LZOLIB_PUBLIC
 
-    sanity = IS_UNSIGNED(unsigned short) && IS_UNSIGNED(unsigned) &&
-	     IS_UNSIGNED(unsigned long) &&
-	     IS_SIGNED(short) && IS_SIGNED(int) && IS_SIGNED(long);
-    if (sanity)
-    {
-	r &= __lzo_assert(IS_UNSIGNED(lzo_uint32));
-	r &= __lzo_assert(IS_UNSIGNED(lzo_uint));
-	r &= __lzo_assert(IS_SIGNED(lzo_int32));
-	r &= __lzo_assert(IS_SIGNED(lzo_int));
-
-	r &= __lzo_assert(INT_MAX    == LZO_STYPE_MAX(sizeof(int)));
-	r &= __lzo_assert(UINT_MAX   == LZO_UTYPE_MAX(sizeof(unsigned)));
-	r &= __lzo_assert(LONG_MAX   == LZO_STYPE_MAX(sizeof(long)));
-	r &= __lzo_assert(ULONG_MAX  == LZO_UTYPE_MAX(sizeof(unsigned long)));
-	r &= __lzo_assert(SHRT_MAX   == LZO_STYPE_MAX(sizeof(short)));
-	r &= __lzo_assert(USHRT_MAX  == LZO_UTYPE_MAX(sizeof(unsigned short)));
-	r &= __lzo_assert(LZO_UINT32_MAX == LZO_UTYPE_MAX(sizeof(lzo_uint32)));
-	r &= __lzo_assert(LZO_UINT_MAX   == LZO_UTYPE_MAX(sizeof(lzo_uint)));
 #if !defined(__LZO_IN_MINILZO)
-	r &= __lzo_assert(SIZE_T_MAX     == LZO_UTYPE_MAX(sizeof(size_t)));
-#endif
-    }
 
-#if 0
-    r &= __lzo_assert(LZO_BYTE(257) == 1);
-    r &= __lzo_assert(LZO_USHORT(65537L) == 1);
-#endif
-
-    return r;
-}
-
-static lzo_bool basic_ptr_check(void)
-{
-    lzo_bool r = 1;
-    lzo_bool sanity;
+#define ACC_WANT_ACC_CHK_CH 1
+#undef ACCCHK_ASSERT
 
-    r &= __lzo_assert(sizeof(char *) >= sizeof(int));
-    r &= __lzo_assert(sizeof(lzo_byte *) >= sizeof(char *));
+    ACCCHK_ASSERT_IS_SIGNED_T(lzo_int)
+    ACCCHK_ASSERT_IS_UNSIGNED_T(lzo_uint)
 
-    r &= __lzo_assert(sizeof(lzo_voidp) == sizeof(lzo_byte *));
-    r &= __lzo_assert(sizeof(lzo_voidp) == sizeof(lzo_voidpp));
-    r &= __lzo_assert(sizeof(lzo_voidp) == sizeof(lzo_bytepp));
-    r &= __lzo_assert(sizeof(lzo_voidp) >= sizeof(lzo_uint));
+    ACCCHK_ASSERT_IS_SIGNED_T(lzo_int32)
+    ACCCHK_ASSERT_IS_UNSIGNED_T(lzo_uint32)
+    ACCCHK_ASSERT((LZO_UINT32_C(1) << (int)(8*sizeof(LZO_UINT32_C(1))-1)) > 0)
+    ACCCHK_ASSERT(sizeof(lzo_uint32) >= 4)
 
-    r &= __lzo_assert(sizeof(lzo_ptr_t) == sizeof(lzo_voidp));
-    r &= __lzo_assert(sizeof(lzo_ptr_t) >= sizeof(lzo_uint));
-
-    r &= __lzo_assert(sizeof(lzo_ptrdiff_t) >= 4);
-    r &= __lzo_assert(sizeof(lzo_ptrdiff_t) >= sizeof(ptrdiff_t));
-
-#if defined(SIZEOF_CHAR_P)
-    r &= __lzo_assert(SIZEOF_CHAR_P == sizeof(char *));
-#endif
-#if defined(SIZEOF_PTRDIFF_T)
-    r &= __lzo_assert(SIZEOF_PTRDIFF_T == sizeof(ptrdiff_t));
+#if !defined(__LZO_UINTPTR_T_IS_POINTER)
+    ACCCHK_ASSERT_IS_UNSIGNED_T(lzo_uintptr_t)
 #endif
+    ACCCHK_ASSERT(sizeof(lzo_uintptr_t) >= sizeof(lzo_voidp))
 
-    sanity = IS_UNSIGNED(unsigned short) && IS_UNSIGNED(unsigned) &&
-	     IS_UNSIGNED(unsigned long) &&
-	     IS_SIGNED(short) && IS_SIGNED(int) && IS_SIGNED(long);
-    if (sanity)
-    {
-	r &= __lzo_assert(IS_UNSIGNED(lzo_ptr_t));
-	r &= __lzo_assert(IS_UNSIGNED(lzo_moff_t));
-	r &= __lzo_assert(IS_SIGNED(lzo_ptrdiff_t));
-	r &= __lzo_assert(IS_SIGNED(lzo_sptr_t));
-    }
-
-    return r;
-}
-
-static lzo_bool ptr_check(void)
-{
-    lzo_bool r = 1;
-    int i;
-    char _wrkmem[10 * sizeof(lzo_byte *) + sizeof(lzo_align_t)];
-    lzo_byte *wrkmem;
-    lzo_bytepp dict;
-    unsigned char x[4 * sizeof(lzo_align_t)];
-    long d;
-    lzo_align_t a;
-
-    for (i = 0; i < (int) sizeof(x); i++)
-	x[i] = LZO_BYTE(i);
-
-    wrkmem = LZO_PTR_ALIGN_UP((lzo_byte *)_wrkmem,sizeof(lzo_align_t));
-    dict = (lzo_bytepp) wrkmem;
-
-    d = (long) ((const lzo_bytep) dict - (const lzo_bytep) _wrkmem);
-    r &= __lzo_assert(d >= 0);
-    r &= __lzo_assert(d < (long) sizeof(lzo_align_t));
-
-    memset(&a,0xff,sizeof(a));
-    r &= __lzo_assert(a.a_ushort == USHRT_MAX);
-    r &= __lzo_assert(a.a_uint == UINT_MAX);
-    r &= __lzo_assert(a.a_ulong == ULONG_MAX);
-    r &= __lzo_assert(a.a_lzo_uint == LZO_UINT_MAX);
-
-    if (r == 1)
-    {
-	for (i = 0; i < 8; i++)
-	    r &= __lzo_assert((const lzo_voidp) (&dict[i]) == (const lzo_voidp) (&wrkmem[i * sizeof(lzo_byte *)]));
-    }
-
-    memset(&a,0,sizeof(a));
-    r &= __lzo_assert(a.a_charp == NULL);
-    r &= __lzo_assert(a.a_lzo_bytep == NULL);
-    //r &= __lzo_assert(NULL == 0);
-    if (r == 1)
-    {
-	for (i = 0; i < 10; i++)
-	    dict[i] = wrkmem;
-	BZERO8_PTR(dict+1,sizeof(dict[0]),8);
-	r &= __lzo_assert(dict[0] == wrkmem);
-	for (i = 1; i < 9; i++)
-	    r &= __lzo_assert(dict[i] == NULL);
-	r &= __lzo_assert(dict[9] == wrkmem);
-    }
-
-    if (r == 1)
-    {
-	unsigned k = 1;
-	const unsigned n = (unsigned) sizeof(lzo_uint32);
-	lzo_byte *p0;
-	lzo_byte *p1;
-
-	k += __lzo_align_gap(&x[k],n);
-	p0 = (lzo_bytep) &x[k];
-#if defined(PTR_LINEAR)
-	r &= __lzo_assert((PTR_LINEAR(p0) & (n-1)) == 0);
-#else
-	r &= __lzo_assert(n == 4);
-	r &= __lzo_assert(PTR_ALIGNED_4(p0));
-#endif
-
-	r &= __lzo_assert(k >= 1);
-	p1 = (lzo_bytep) &x[1];
-	r &= __lzo_assert(PTR_GE(p0,p1));
-
-	r &= __lzo_assert(k < 1+n);
-	p1 = (lzo_bytep) &x[1+n];
-	r &= __lzo_assert(PTR_LT(p0,p1));
-
-	if (r == 1)
-	{
-	    lzo_uint32 v0 = * (lzo_uint32 *) &x[k];
-	    lzo_uint32 v1 = * (lzo_uint32 *) &x[k+n];
-
-	    r &= __lzo_assert(v0 > 0);
-	    r &= __lzo_assert(v1 > 0);
-	}
-    }
+    ACCCHK_ASSERT_IS_UNSIGNED_T(lzo_xint)
+    ACCCHK_ASSERT(sizeof(lzo_xint) >= sizeof(lzo_uint32))
+    ACCCHK_ASSERT(sizeof(lzo_xint) >= sizeof(lzo_uint))
+    ACCCHK_ASSERT(sizeof(lzo_xint) == sizeof(lzo_uint32) || sizeof(lzo_xint) == sizeof(lzo_uint))
 
-    return r;
-}
+#endif
+#undef ACCCHK_ASSERT
 
 LZO_PUBLIC(int)
 _lzo_config_check(void)
 {
     lzo_bool r = 1;
-    int i;
-    union {
-	lzo_uint32 a;
-	unsigned short b;
-	lzo_uint32 aa[4];
-	unsigned char x[4*sizeof(lzo_align_t)];
-    } u;
+    union { unsigned char c[2*sizeof(lzo_xint)]; lzo_xint l[2]; } u;
 
-#if 0
-    r &= __lzo_assert((const void *)&u == (const void *)&u.a);
-    r &= __lzo_assert((const void *)&u == (const void *)&u.b);
-    r &= __lzo_assert((const void *)&u == (const void *)&u.x[0]);
-    r &= __lzo_assert((const void *)&u == (const void *)&u.aa[0]);
-#endif
-
-    r &= basic_integral_check();
-    r &= basic_ptr_check();
-    if (r != 1)
-	return LZO_E_ERROR;
-
-    u.a = 0; u.b = 0;
-    for (i = 0; i < (int) sizeof(u.x); i++)
-	u.x[i] = LZO_BYTE(i);
-
-#if 0
-    r &= __lzo_assert( (int) (unsigned char) ((char) -1) == 255);
-#endif
-
-#if defined(LZO_BYTE_ORDER)
-    if (r == 1)
-    {
-#  if (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
-	lzo_uint32 a = (lzo_uint32) (u.a & LZO_0xffffffffL);
-	unsigned short b = (unsigned short) (u.b & 0xffff);
-	r &= __lzo_assert(a == 0x03020100L);
-	r &= __lzo_assert(b == 0x0100);
-#  elif (LZO_BYTE_ORDER == LZO_BIG_ENDIAN)
-	lzo_uint32 a = u.a >> (8 * sizeof(u.a) - 32);
-	unsigned short b = u.b >> (8 * sizeof(u.b) - 16);
-	r &= __lzo_assert(a == 0x00010203L);
-	r &= __lzo_assert(b == 0x0001);
-#  else
-#    error invalid LZO_BYTE_ORDER
-#  endif
-    }
+#if !defined(LZO_CFG_NO_CONFIG_CHECK)
+#if defined(LZO_ABI_BIG_ENDIAN)
+    u.l[0] = u.l[1] = 0; u.c[sizeof(lzo_xint) - 1] = 128;
+    r &= (u.l[0] == 128);
+#endif
+#if defined(LZO_ABI_LITTLE_ENDIAN)
+    u.l[0] = u.l[1] = 0; u.c[0] = 128;
+    r &= (u.l[0] == 128);
 #endif
-
 #if defined(LZO_UNALIGNED_OK_2)
-    r &= __lzo_assert(sizeof(short) == 2);
-    if (r == 1)
-    {
-	unsigned short b[4];
-
-	for (i = 0; i < 4; i++)
-	    b[i] = * (const unsigned short *) &u.x[i];
-
-#  if (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
-	r &= __lzo_assert(b[0] == 0x0100);
-	r &= __lzo_assert(b[1] == 0x0201);
-	r &= __lzo_assert(b[2] == 0x0302);
-	r &= __lzo_assert(b[3] == 0x0403);
-#  elif (LZO_BYTE_ORDER == LZO_BIG_ENDIAN)
-	r &= __lzo_assert(b[0] == 0x0001);
-	r &= __lzo_assert(b[1] == 0x0102);
-	r &= __lzo_assert(b[2] == 0x0203);
-	r &= __lzo_assert(b[3] == 0x0304);
-#  endif
-    }
+    u.l[0] = u.l[1] = 0;
+    r &= ((* (const lzo_ushortp) (const lzo_voidp) &u.c[1]) == 0);
 #endif
-
 #if defined(LZO_UNALIGNED_OK_4)
-    r &= __lzo_assert(sizeof(lzo_uint32) == 4);
-    if (r == 1)
-    {
-	lzo_uint32 a[4];
-
-	for (i = 0; i < 4; i++)
-	    a[i] = * (const lzo_uint32 *) &u.x[i];
-
-#  if (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
-	r &= __lzo_assert(a[0] == 0x03020100L);
-	r &= __lzo_assert(a[1] == 0x04030201L);
-	r &= __lzo_assert(a[2] == 0x05040302L);
-	r &= __lzo_assert(a[3] == 0x06050403L);
-#  elif (LZO_BYTE_ORDER == LZO_BIG_ENDIAN)
-	r &= __lzo_assert(a[0] == 0x00010203L);
-	r &= __lzo_assert(a[1] == 0x01020304L);
-	r &= __lzo_assert(a[2] == 0x02030405L);
-	r &= __lzo_assert(a[3] == 0x03040506L);
-#  endif
-    }
-#endif
-
-#if defined(LZO_ALIGNED_OK_4)
-    r &= __lzo_assert(sizeof(lzo_uint32) == 4);
+    u.l[0] = u.l[1] = 0;
+    r &= ((* (const lzo_uint32p) (const lzo_voidp) &u.c[1]) == 0);
 #endif
-
-    r &= __lzo_assert(lzo_sizeof_dict_t == sizeof(lzo_dict_t));
-
-#if defined(__LZO_IN_MINLZO)
-    if (r == 1)
-    {
-	lzo_uint32 adler;
-	adler = lzo_adler32(0, NULL, 0);
-	adler = lzo_adler32(adler, lzo_copyright(), 200);
-	r &= __lzo_assert(adler == 0x7ea34377L);
-    }
 #endif
 
-    if (r == 1)
-    {
-	r &= __lzo_assert(!schedule_insns_bug());
-    }
-
-    if (r == 1)
-    {
-	static int x[3];
-	static unsigned xn = 3;
-	register unsigned j;
-
-	for (j = 0; j < xn; j++)
-	    x[j] = (int)j - 3;
-	r &= __lzo_assert(!strength_reduce_bug(x));
-    }
-
-    if (r == 1)
-    {
-	r &= ptr_check();
-    }
-
+    LZO_UNUSED(u);
     return r == 1 ? LZO_E_OK : LZO_E_ERROR;
 }
 
-static lzo_bool schedule_insns_bug(void)
-{
-#if defined(__LZO_CHECKER)
-    return 0;
-#else
-    const int clone[] = {1, 2, 0};
-    const int *q;
-    q = clone;
-    return (*q) ? 0 : 1;
-#endif
-}
-
-static lzo_bool strength_reduce_bug(int *x)
-{
-    return x[0] != -3 || x[1] != -2 || x[2] != -1;
-}
-
 int __lzo_init_done = 0;
 
 LZO_PUBLIC(int)
-__lzo_init2(unsigned v, int s1, int s2, int s3, int s4, int s5,
-			int s6, int s7, int s8, int s9)
+__lzo_init_v2(unsigned v, int s1, int s2, int s3, int s4, int s5,
+                          int s6, int s7, int s8, int s9)
 {
     int r;
 
+#if defined(__LZO_IN_MINILZO)
+#elif (LZO_CC_MSC && ((_MSC_VER) < 700))
+#else
+#define ACC_WANT_ACC_CHK_CH 1
+#undef ACCCHK_ASSERT
+#define ACCCHK_ASSERT(expr)  LZO_COMPILE_TIME_ASSERT(expr)
+#endif
+#undef ACCCHK_ASSERT
+
     __lzo_init_done = 1;
 
     if (v == 0)
-	return LZO_E_ERROR;
+        return LZO_E_ERROR;
 
     r = (s1 == -1 || s1 == (int) sizeof(short)) &&
-	(s2 == -1 || s2 == (int) sizeof(int)) &&
-	(s3 == -1 || s3 == (int) sizeof(long)) &&
-	(s4 == -1 || s4 == (int) sizeof(lzo_uint32)) &&
-	(s5 == -1 || s5 == (int) sizeof(lzo_uint)) &&
-	(s6 == -1 || s6 == (int) lzo_sizeof_dict_t) &&
-	(s7 == -1 || s7 == (int) sizeof(char *)) &&
-	(s8 == -1 || s8 == (int) sizeof(lzo_voidp)) &&
-	(s9 == -1 || s9 == (int) sizeof(lzo_compress_t));
+        (s2 == -1 || s2 == (int) sizeof(int)) &&
+        (s3 == -1 || s3 == (int) sizeof(long)) &&
+        (s4 == -1 || s4 == (int) sizeof(lzo_uint32)) &&
+        (s5 == -1 || s5 == (int) sizeof(lzo_uint)) &&
+        (s6 == -1 || s6 == (int) lzo_sizeof_dict_t) &&
+        (s7 == -1 || s7 == (int) sizeof(char *)) &&
+        (s8 == -1 || s8 == (int) sizeof(lzo_voidp)) &&
+        (s9 == -1 || s9 == (int) sizeof(lzo_callback_t));
     if (!r)
-	return LZO_E_ERROR;
+        return LZO_E_ERROR;
 
     r = _lzo_config_check();
     if (r != LZO_E_OK)
-	return r;
+        return r;
 
     return r;
 }
 
 #if !defined(__LZO_IN_MINILZO)
 
-LZO_EXTERN(int)
-__lzo_init(unsigned v,int s1,int s2,int s3,int s4,int s5,int s6,int s7);
+#if (LZO_OS_WIN16 && LZO_CC_WATCOMC) && defined(__SW_BD)
 
-LZO_PUBLIC(int)
-__lzo_init(unsigned v,int s1,int s2,int s3,int s4,int s5,int s6,int s7)
+#if 0
+BOOL FAR PASCAL LibMain ( HANDLE hInstance, WORD wDataSegment,
+                          WORD wHeapSize, LPSTR lpszCmdLine )
+#else
+int __far __pascal LibMain ( int a, short b, short c, long d )
+#endif
 {
-    if (v == 0 || v > 0x1010)
-	return LZO_E_ERROR;
-    return __lzo_init2(v,s1,s2,s3,s4,s5,-1,-1,s6,s7);
+    LZO_UNUSED(a); LZO_UNUSED(b); LZO_UNUSED(c); LZO_UNUSED(d);
+    return 1;
 }
 
 #endif
 
+#endif
+
 #define do_compress         _lzo1x_1_do_compress
 
 #define LZO_NEED_DICT_H
 #define D_BITS          14
-#define D_INDEX1(d,p)       d = DM((0x21*DX3(p,5,5,6)) >> 5)
+#define D_INDEX1(d,p)       d = DM(DMUL(0x21,DX3(p,5,5,6)) >> 5)
 #define D_INDEX2(d,p)       d = (d & (D_MASK & 0x7ff)) ^ (D_HIGH | 0x1f)
 
 #ifndef __LZO_CONFIG1X_H
@@ -1307,7 +2190,7 @@
 #endif
 
 #if !defined(__LZO_IN_MINILZO)
-#include <lzo1x.h>
+#include "lzo/lzo1x.h"
 #endif
 
 #define LZO_EOF_CODE
@@ -1360,7 +2243,7 @@
 #  define D_BITS        DBITS
 #endif
 #if !defined(D_BITS)
-#  error D_BITS is not defined
+#  error "D_BITS is not defined"
 #endif
 #if (D_BITS < 16)
 #  define D_SIZE        LZO_SIZE(D_BITS)
@@ -1389,16 +2272,16 @@
 #endif
 
 #if (D_BITS != DL_BITS + DD_BITS)
-#  error D_BITS does not match
+#  error "D_BITS does not match"
 #endif
 #if (D_BITS < 8 || D_BITS > 18)
-#  error invalid D_BITS
+#  error "invalid D_BITS"
 #endif
 #if (DL_BITS < 8 || DL_BITS > 20)
-#  error invalid DL_BITS
+#  error "invalid DL_BITS"
 #endif
 #if (DD_BITS < 0 || DD_BITS > 6)
-#  error invalid DD_BITS
+#  error "invalid DD_BITS"
 #endif
 
 #if !defined(DL_MIN_LEN)
@@ -1414,32 +2297,35 @@
 #define LZO_HASH_LZO_INCREMENTAL_B      4
 
 #if !defined(LZO_HASH)
-#  error choose a hashing strategy
+#  error "choose a hashing strategy"
 #endif
 
+#undef DM
+#undef DX
+
 #if (DL_MIN_LEN == 3)
 #  define _DV2_A(p,shift1,shift2) \
-	(((( (lzo_uint32)((p)[0]) << shift1) ^ (p)[1]) << shift2) ^ (p)[2])
+        (((( (lzo_xint)((p)[0]) << shift1) ^ (p)[1]) << shift2) ^ (p)[2])
 #  define _DV2_B(p,shift1,shift2) \
-	(((( (lzo_uint32)((p)[2]) << shift1) ^ (p)[1]) << shift2) ^ (p)[0])
+        (((( (lzo_xint)((p)[2]) << shift1) ^ (p)[1]) << shift2) ^ (p)[0])
 #  define _DV3_B(p,shift1,shift2,shift3) \
-	((_DV2_B((p)+1,shift1,shift2) << (shift3)) ^ (p)[0])
+        ((_DV2_B((p)+1,shift1,shift2) << (shift3)) ^ (p)[0])
 #elif (DL_MIN_LEN == 2)
 #  define _DV2_A(p,shift1,shift2) \
-	(( (lzo_uint32)(p[0]) << shift1) ^ p[1])
+        (( (lzo_xint)(p[0]) << shift1) ^ p[1])
 #  define _DV2_B(p,shift1,shift2) \
-	(( (lzo_uint32)(p[1]) << shift1) ^ p[2])
+        (( (lzo_xint)(p[1]) << shift1) ^ p[2])
 #else
-#  error invalid DL_MIN_LEN
+#  error "invalid DL_MIN_LEN"
 #endif
 #define _DV_A(p,shift)      _DV2_A(p,shift,shift)
 #define _DV_B(p,shift)      _DV2_B(p,shift,shift)
 #define DA2(p,s1,s2) \
-	(((((lzo_uint32)((p)[2]) << (s2)) + (p)[1]) << (s1)) + (p)[0])
+        (((((lzo_xint)((p)[2]) << (s2)) + (p)[1]) << (s1)) + (p)[0])
 #define DS2(p,s1,s2) \
-	(((((lzo_uint32)((p)[2]) << (s2)) - (p)[1]) << (s1)) - (p)[0])
+        (((((lzo_xint)((p)[2]) << (s2)) - (p)[1]) << (s1)) - (p)[0])
 #define DX2(p,s1,s2) \
-	(((((lzo_uint32)((p)[2]) << (s2)) ^ (p)[1]) << (s1)) ^ (p)[0])
+        (((((lzo_xint)((p)[2]) << (s2)) ^ (p)[1]) << (s1)) ^ (p)[0])
 #define DA3(p,s1,s2,s3) ((DA2((p)+1,s2,s3) << (s1)) + (p)[0])
 #define DS3(p,s1,s2,s3) ((DS2((p)+1,s2,s3) << (s1)) - (p)[0])
 #define DX3(p,s1,s2,s3) ((DX2((p)+1,s2,s3) << (s1)) ^ (p)[0])
@@ -1460,20 +2346,20 @@
 #  define __LZO_HASH_INCREMENTAL
 #  define DVAL_FIRST(dv,p)  dv = _DV_A((p),5)
 #  define DVAL_NEXT(dv,p) \
-		dv ^= (lzo_uint32)(p[-1]) << (2*5); dv = (((dv) << 5) ^ p[2])
-#  define _DINDEX(dv,p)     ((0x9f5f * (dv)) >> 5)
+                dv ^= (lzo_xint)(p[-1]) << (2*5); dv = (((dv) << 5) ^ p[2])
+#  define _DINDEX(dv,p)     ((DMUL(0x9f5f,dv)) >> 5)
 #  define DVAL_LOOKAHEAD    DL_MIN_LEN
 
 #elif (LZO_HASH == LZO_HASH_LZO_INCREMENTAL_B)
 #  define __LZO_HASH_INCREMENTAL
 #  define DVAL_FIRST(dv,p)  dv = _DV_B((p),5)
 #  define DVAL_NEXT(dv,p) \
-		dv ^= p[-1]; dv = (((dv) >> 5) ^ ((lzo_uint32)(p[2]) << (2*5)))
-#  define _DINDEX(dv,p)     ((0x9f5f * (dv)) >> 5)
+                dv ^= p[-1]; dv = (((dv) >> 5) ^ ((lzo_xint)(p[2]) << (2*5)))
+#  define _DINDEX(dv,p)     ((DMUL(0x9f5f,dv)) >> 5)
 #  define DVAL_LOOKAHEAD    DL_MIN_LEN
 
 #else
-#  error choose a hashing strategy
+#  error "choose a hashing strategy"
 #endif
 
 #ifndef DINDEX
@@ -1494,9 +2380,9 @@
 
 #if !defined(DVAL_ASSERT)
 #if defined(__LZO_HASH_INCREMENTAL) && !defined(NDEBUG)
-static void DVAL_ASSERT(lzo_uint32 dv, const lzo_byte *p)
+static void DVAL_ASSERT(lzo_xint dv, const lzo_bytep p)
 {
-    lzo_uint32 df;
+    lzo_xint df;
     DVAL_FIRST(df,(p));
     assert(DINDEX(dv,p) == DINDEX(df,p));
 }
@@ -1522,36 +2408,37 @@
 #else
 
 #  define UPDATE_D(dict,drun,dv,p,in)   \
-	dict[ DINDEX(dv,p) + drun++ ] = DENTRY(p,in); drun &= DD_MASK
+        dict[ DINDEX(dv,p) + drun++ ] = DENTRY(p,in); drun &= DD_MASK
 #  define UPDATE_I(dict,drun,index,p,in)    \
-	dict[ (index) + drun++ ] = DENTRY(p,in); drun &= DD_MASK
+        dict[ (index) + drun++ ] = DENTRY(p,in); drun &= DD_MASK
 #  define UPDATE_P(ptr,drun,p,in)   \
-	(ptr) [ drun++ ] = DENTRY(p,in); drun &= DD_MASK
+        (ptr) [ drun++ ] = DENTRY(p,in); drun &= DD_MASK
 
 #endif
 
 #if defined(LZO_DICT_USE_PTR)
 
 #define LZO_CHECK_MPOS_DET(m_pos,m_off,in,ip,max_offset) \
-	(m_pos == NULL || (m_off = (lzo_moff_t) (ip - m_pos)) > max_offset)
+        (m_pos == NULL || (m_off = pd(ip, m_pos)) > max_offset)
 
 #define LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,max_offset) \
-    (BOUNDS_CHECKING_OFF_IN_EXPR( \
-	(PTR_LT(m_pos,in) || \
-	 (m_off = (lzo_moff_t) PTR_DIFF(ip,m_pos)) <= 0 || \
-	  m_off > max_offset) ))
+    (BOUNDS_CHECKING_OFF_IN_EXPR(( \
+        m_pos = ip - (lzo_uint) PTR_DIFF(ip,m_pos), \
+        PTR_LT(m_pos,in) || \
+        (m_off = (lzo_uint) PTR_DIFF(ip,m_pos)) <= 0 || \
+         m_off > max_offset )))
 
 #else
 
 #define LZO_CHECK_MPOS_DET(m_pos,m_off,in,ip,max_offset) \
-	(m_off == 0 || \
-	 ((m_off = (lzo_moff_t) ((ip)-(in)) - m_off) > max_offset) || \
-	 (m_pos = (ip) - (m_off), 0) )
+        (m_off == 0 || \
+         ((m_off = pd(ip, in) - m_off) > max_offset) || \
+         (m_pos = (ip) - (m_off), 0) )
 
 #define LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,max_offset) \
-	((lzo_moff_t) ((ip)-(in)) <= m_off || \
-	 ((m_off = (lzo_moff_t) ((ip)-(in)) - m_off) > max_offset) || \
-	 (m_pos = (ip) - (m_off), 0) )
+        (pd(ip, in) <= m_off || \
+         ((m_off = pd(ip, in) - m_off) > max_offset) || \
+         (m_pos = (ip) - (m_off), 0) )
 
 #endif
 
@@ -1573,20 +2460,16 @@
 
 #define DO_COMPRESS     lzo1x_1_compress
 
-static
-lzo_uint do_compress     ( const lzo_byte *in , lzo_uint  in_len,
-				 lzo_byte *out, lzo_uint *out_len,
-				 lzo_voidp wrkmem )
-{
-#if 0 && defined(__GNUC__) && defined(__i386__)
-    register const lzo_byte *ip __asm__("%esi");
-#else
-    register const lzo_byte *ip;
-#endif
-    lzo_byte *op;
-    const lzo_byte * const in_end = in + in_len;
-    const lzo_byte * const ip_end = in + in_len - M2_MAX_LEN - 5;
-    const lzo_byte *ii;
+static lzo_uint __lzo_noinline
+do_compress ( const lzo_bytep in , lzo_uint  in_len,
+                    lzo_bytep out, lzo_uintp out_len,
+                    lzo_voidp wrkmem )
+{
+    register const lzo_bytep ip;
+    lzo_bytep op;
+    const lzo_bytep const in_end = in + in_len;
+    const lzo_bytep const ip_end = in + in_len - M2_MAX_LEN - 5;
+    const lzo_bytep ii;
     lzo_dict_p const dict = (lzo_dict_p) wrkmem;
 
     op = out;
